package com.example.service;

import com.example.util.JsonMappingUtils;
import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.mockito.InjectMocks;
import org.mockito.Mock;
import org.powermock.core.classloader.annotations.PrepareForTest;
import org.powermock.modules.junit4.PowerMockRunner;

import java.io.FileInputStream;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;

import static org.mockito.Matchers.anyString;
import static org.powermock.api.mockito.PowerMockito.*;

@RunWith(PowerMockRunner.class)
@PrepareForTest({JsonMappingUtils.class, CsvReader.class})
public class CsvReaderTest {

    @InjectMocks
    CsvReader csvReader;

    @Mock
    CopientKafkaService kafkaService;

    @Before
    public void setUp() throws Exception {
        mockStatic(JsonMappingUtils.class);
        FileInputStream inputStream = mock(FileInputStream.class);
        whenNew(FileInputStream.class).withAnyArguments().thenReturn(inputStream);
        Scanner scanner = new Scanner(createCsvDataStub());
        whenNew(Scanner.class).withAnyArguments().thenReturn(scanner);
        JsonMappingUtils mappingStub = mock(JsonMappingUtils.class);
        when(JsonMappingUtils.getDefaultInstance()).thenReturn(mappingStub);
        when(mappingStub.getJsonVarToCsvDataIndex()).thenReturn(createMappingCsvKeyStub());
       // doNothing().when(kafkaService).sendDataToKafkaTopic(anyString());
    }

    private String createCsvDataStub() {
        return "Department,First Name,Last Name,Primary Contact,E-Mail Address,Phone Number,Role\n" +
                "Austin Fire,Christine,Thies,Yes,Christine.Thies@ausps.org,512-974-4119,Liaison\n" +
                "Austin Fire,Gus,Delgado,,gus.delgado@austintexas.gov,512-974-2359,Backup Liaison";
    }

    private Map<String, Integer> createMappingCsvKeyStub() {
        Map<String, Integer> csvKeys = new HashMap<>();
        csvKeys.put("department_name", 0);
        csvKeys.put("first_name", 1);
        csvKeys.put("last_name", 2);
        csvKeys.put("primary_contact", 3);
        csvKeys.put("email_address", 4);
        csvKeys.put("phone_number", 5);
        csvKeys.put("role", 6);
        return csvKeys;
    }

    @Test
    public void convert() throws IOException {
        String jsonTest = csvReader.convert("", "");
        System.out.println(jsonTest);
    }
}